import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "../../common";
export interface ForwarderBaseInterface extends utils.Interface {
    functions: {
        "__Forwarder_init(address)": FunctionFragment;
        "crossDomainAdmin()": FunctionFragment;
        "proxiableUUID()": FunctionFragment;
        "relayMessage(address,uint256,bytes)": FunctionFragment;
        "relayTokens(address,address,uint256,uint256,address)": FunctionFragment;
        "setCrossDomainAdmin(address)": FunctionFragment;
        "updateAdapter(uint256,address)": FunctionFragment;
        "upgradeTo(address)": FunctionFragment;
        "upgradeToAndCall(address,bytes)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "__Forwarder_init" | "crossDomainAdmin" | "proxiableUUID" | "relayMessage" | "relayTokens" | "setCrossDomainAdmin" | "updateAdapter" | "upgradeTo" | "upgradeToAndCall"): FunctionFragment;
    encodeFunctionData(functionFragment: "__Forwarder_init", values: [string]): string;
    encodeFunctionData(functionFragment: "crossDomainAdmin", values?: undefined): string;
    encodeFunctionData(functionFragment: "proxiableUUID", values?: undefined): string;
    encodeFunctionData(functionFragment: "relayMessage", values: [string, BigNumberish, BytesLike]): string;
    encodeFunctionData(functionFragment: "relayTokens", values: [string, string, BigNumberish, BigNumberish, string]): string;
    encodeFunctionData(functionFragment: "setCrossDomainAdmin", values: [string]): string;
    encodeFunctionData(functionFragment: "updateAdapter", values: [BigNumberish, string]): string;
    encodeFunctionData(functionFragment: "upgradeTo", values: [string]): string;
    encodeFunctionData(functionFragment: "upgradeToAndCall", values: [string, BytesLike]): string;
    decodeFunctionResult(functionFragment: "__Forwarder_init", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "crossDomainAdmin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "proxiableUUID", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "relayMessage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "relayTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setCrossDomainAdmin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateAdapter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeToAndCall", data: BytesLike): Result;
    events: {
        "AdminChanged(address,address)": EventFragment;
        "BeaconUpgraded(address)": EventFragment;
        "ChainAdaptersUpdated(uint256,address)": EventFragment;
        "Initialized(uint8)": EventFragment;
        "MessageForwarded(address,uint256,bytes)": EventFragment;
        "SetXDomainAdmin(address)": EventFragment;
        "TokensForwarded(address,address,uint256,uint256,address)": EventFragment;
        "Upgraded(address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "AdminChanged"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "BeaconUpgraded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ChainAdaptersUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Initialized"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "MessageForwarded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetXDomainAdmin"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "TokensForwarded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Upgraded"): EventFragment;
}
export interface AdminChangedEventObject {
    previousAdmin: string;
    newAdmin: string;
}
export type AdminChangedEvent = TypedEvent<[
    string,
    string
], AdminChangedEventObject>;
export type AdminChangedEventFilter = TypedEventFilter<AdminChangedEvent>;
export interface BeaconUpgradedEventObject {
    beacon: string;
}
export type BeaconUpgradedEvent = TypedEvent<[
    string
], BeaconUpgradedEventObject>;
export type BeaconUpgradedEventFilter = TypedEventFilter<BeaconUpgradedEvent>;
export interface ChainAdaptersUpdatedEventObject {
    destinationChainId: BigNumber;
    l2Adapter: string;
}
export type ChainAdaptersUpdatedEvent = TypedEvent<[
    BigNumber,
    string
], ChainAdaptersUpdatedEventObject>;
export type ChainAdaptersUpdatedEventFilter = TypedEventFilter<ChainAdaptersUpdatedEvent>;
export interface InitializedEventObject {
    version: number;
}
export type InitializedEvent = TypedEvent<[number], InitializedEventObject>;
export type InitializedEventFilter = TypedEventFilter<InitializedEvent>;
export interface MessageForwardedEventObject {
    target: string;
    chainId: BigNumber;
    message: string;
}
export type MessageForwardedEvent = TypedEvent<[
    string,
    BigNumber,
    string
], MessageForwardedEventObject>;
export type MessageForwardedEventFilter = TypedEventFilter<MessageForwardedEvent>;
export interface SetXDomainAdminEventObject {
    crossDomainAdmin: string;
}
export type SetXDomainAdminEvent = TypedEvent<[
    string
], SetXDomainAdminEventObject>;
export type SetXDomainAdminEventFilter = TypedEventFilter<SetXDomainAdminEvent>;
export interface TokensForwardedEventObject {
    baseToken: string;
    remoteToken: string;
    amount: BigNumber;
    destinationChainId: BigNumber;
    to: string;
}
export type TokensForwardedEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber,
    string
], TokensForwardedEventObject>;
export type TokensForwardedEventFilter = TypedEventFilter<TokensForwardedEvent>;
export interface UpgradedEventObject {
    implementation: string;
}
export type UpgradedEvent = TypedEvent<[string], UpgradedEventObject>;
export type UpgradedEventFilter = TypedEventFilter<UpgradedEvent>;
export interface ForwarderBase extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ForwarderBaseInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        __Forwarder_init(_crossDomainAdmin: string, overrides?: Overrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        crossDomainAdmin(overrides?: CallOverrides): Promise<[string]>;
        proxiableUUID(overrides?: CallOverrides): Promise<[string]>;
        relayMessage(target: string, destinationChainId: BigNumberish, message: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        relayTokens(baseToken: string, destinationChainToken: string, amount: BigNumberish, destinationChainId: BigNumberish, target: string, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        setCrossDomainAdmin(_newCrossDomainAdmin: string, overrides?: Overrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        updateAdapter(_destinationChainId: BigNumberish, _l2Adapter: string, overrides?: Overrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<ContractTransaction>;
    };
    __Forwarder_init(_crossDomainAdmin: string, overrides?: Overrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    crossDomainAdmin(overrides?: CallOverrides): Promise<string>;
    proxiableUUID(overrides?: CallOverrides): Promise<string>;
    relayMessage(target: string, destinationChainId: BigNumberish, message: BytesLike, overrides?: PayableOverrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    relayTokens(baseToken: string, destinationChainToken: string, amount: BigNumberish, destinationChainId: BigNumberish, target: string, overrides?: PayableOverrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    setCrossDomainAdmin(_newCrossDomainAdmin: string, overrides?: Overrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    updateAdapter(_destinationChainId: BigNumberish, _l2Adapter: string, overrides?: Overrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    upgradeTo(newImplementation: string, overrides?: Overrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    callStatic: {
        __Forwarder_init(_crossDomainAdmin: string, overrides?: CallOverrides): Promise<void>;
        crossDomainAdmin(overrides?: CallOverrides): Promise<string>;
        proxiableUUID(overrides?: CallOverrides): Promise<string>;
        relayMessage(target: string, destinationChainId: BigNumberish, message: BytesLike, overrides?: CallOverrides): Promise<void>;
        relayTokens(baseToken: string, destinationChainToken: string, amount: BigNumberish, destinationChainId: BigNumberish, target: string, overrides?: CallOverrides): Promise<void>;
        setCrossDomainAdmin(_newCrossDomainAdmin: string, overrides?: CallOverrides): Promise<void>;
        updateAdapter(_destinationChainId: BigNumberish, _l2Adapter: string, overrides?: CallOverrides): Promise<void>;
        upgradeTo(newImplementation: string, overrides?: CallOverrides): Promise<void>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "AdminChanged(address,address)"(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        AdminChanged(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        "BeaconUpgraded(address)"(beacon?: string | null): BeaconUpgradedEventFilter;
        BeaconUpgraded(beacon?: string | null): BeaconUpgradedEventFilter;
        "ChainAdaptersUpdated(uint256,address)"(destinationChainId?: BigNumberish | null, l2Adapter?: null): ChainAdaptersUpdatedEventFilter;
        ChainAdaptersUpdated(destinationChainId?: BigNumberish | null, l2Adapter?: null): ChainAdaptersUpdatedEventFilter;
        "Initialized(uint8)"(version?: null): InitializedEventFilter;
        Initialized(version?: null): InitializedEventFilter;
        "MessageForwarded(address,uint256,bytes)"(target?: string | null, chainId?: BigNumberish | null, message?: null): MessageForwardedEventFilter;
        MessageForwarded(target?: string | null, chainId?: BigNumberish | null, message?: null): MessageForwardedEventFilter;
        "SetXDomainAdmin(address)"(crossDomainAdmin?: string | null): SetXDomainAdminEventFilter;
        SetXDomainAdmin(crossDomainAdmin?: string | null): SetXDomainAdminEventFilter;
        "TokensForwarded(address,address,uint256,uint256,address)"(baseToken?: null, remoteToken?: null, amount?: null, destinationChainId?: BigNumberish | null, to?: string | null): TokensForwardedEventFilter;
        TokensForwarded(baseToken?: null, remoteToken?: null, amount?: null, destinationChainId?: BigNumberish | null, to?: string | null): TokensForwardedEventFilter;
        "Upgraded(address)"(implementation?: string | null): UpgradedEventFilter;
        Upgraded(implementation?: string | null): UpgradedEventFilter;
    };
    estimateGas: {
        __Forwarder_init(_crossDomainAdmin: string, overrides?: Overrides & {
            from?: string;
        }): Promise<BigNumber>;
        crossDomainAdmin(overrides?: CallOverrides): Promise<BigNumber>;
        proxiableUUID(overrides?: CallOverrides): Promise<BigNumber>;
        relayMessage(target: string, destinationChainId: BigNumberish, message: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<BigNumber>;
        relayTokens(baseToken: string, destinationChainToken: string, amount: BigNumberish, destinationChainId: BigNumberish, target: string, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<BigNumber>;
        setCrossDomainAdmin(_newCrossDomainAdmin: string, overrides?: Overrides & {
            from?: string;
        }): Promise<BigNumber>;
        updateAdapter(_destinationChainId: BigNumberish, _l2Adapter: string, overrides?: Overrides & {
            from?: string;
        }): Promise<BigNumber>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string;
        }): Promise<BigNumber>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        __Forwarder_init(_crossDomainAdmin: string, overrides?: Overrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        crossDomainAdmin(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        proxiableUUID(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        relayMessage(target: string, destinationChainId: BigNumberish, message: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        relayTokens(baseToken: string, destinationChainToken: string, amount: BigNumberish, destinationChainId: BigNumberish, target: string, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        setCrossDomainAdmin(_newCrossDomainAdmin: string, overrides?: Overrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        updateAdapter(_destinationChainId: BigNumberish, _l2Adapter: string, overrides?: Overrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
    };
}
